{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load widget_tweaks %}

{% block title %}Matrix - Inspección de calidad{% endblock %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
  <li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
  <li class="breadcrumb-item"><a href="{% url 'call-qa-list' %}">Listado de inspecciones de calidad</a></li>
  <!--li class="breadcrumb-item"><a href="{% url 'call-qa-create' %}">Registro de calidad de llamadas</a></li-->
  <li class="breadcrumb-item active">Crear Registro</li>
</ol>
<!-- end breadcrumb -->
<!-- begin page-header -->
<h1 class="page-header">QC <small>Registro de inspección de calidad</small></h1>
<!-- end page-header -->

<!-- begin row -->
<div class="row">
    {% if form %}
    <!-- begin col-12 -->
    <div class="col-xl-12">
      <!-- begin panel -->
      <div class="panel panel-inverse" data-sortable-id="table-basic-1">
        <!-- begin panel-heading -->
        <div class="panel-heading">
          <h4 class="panel-title">{{ service.customer.name }}</h4>
          <div class="panel-heading-btn">
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
            <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
          </div>
        </div>
        <!-- end panel-heading -->
        <div class="panel-body">

              <form id="call-qa-form" class="form-horizontal" method="post">
                {% csrf_token %}
                <div class="row justify-content-center">
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.call_date.auto_id }}">{{ form.call_date.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.call_date class="form-control m-b-5" %}

                      {% for error in form.call_date.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.call_time.auto_id }}">{{ form.call_time.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.call_time class="form-control m-b-5" placeholder="hh:mm"%}

                      {% for error in form.call_time.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.agent.auto_id }}">{{ form.agent.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.agent class="form-control m-b-5" %}

                      {% for error in form.agent.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.kind.auto_id }}">{{ form.kind.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.kind class="form-control m-b-5" %}

                      {% for error in form.kind.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel d-none">
                    <div class="field-panel-heading">
                      <label for="{{ form.channel.auto_id }}">{{ form.channel.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.channel class="form-control m-b-5" %}

                      {% for error in form.channel.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.customer_phone.auto_id }}">{{ form.customer_phone.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.customer_phone class="form-control m-b-5" %}

                      {% for error in form.customer_phone.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                      <small id="phone-format-error" class="f-s-12 text-danger d-none"></small>
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.email.auto_id }}">{{ form.email.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.email class="form-control m-b-5" %}

                      {% for error in form.email.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                      <small id="email-format-error" class="f-s-12 text-danger d-none"></small>
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.rut.auto_id }}">{{ form.rut.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.rut class="form-control m-b-5" maxlength="12"%}

                      {% for error in form.rut.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                      <small id="rut-format-error" class="f-s-12 text-danger d-none"></small>
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.service.auto_id }}">{{ form.service.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      <select name="service" class="form-control m-b-5" id="id_service" multiple="multiple">
                      </select>

                      {% for error in form.service.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.typing.auto_id }}">{{ form.typing.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.typing class="form-control m-b-5" %}

                      {% for error in form.typing.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.category.auto_id }}">{{ form.category.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      <select name="category" class="form-control m-b-5" id="id_category">
                        {% if categories %}
                        <option value="">---------</option>
                        {% for category in categories %}
                        {% if category.0 == active_category %}
                        <option value="{{ category.0 }}" selected>{{ category.1 }}</option>
                        {% else %}
                        <option value="{{ category.0 }}">{{ category.1 }}</option>
                        {% endif %}
                        {% endfor %}
                        {% endif %}
                      </select>

                      {% for error in form.category.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.subcategory.auto_id }}">{{ form.subcategory.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      <select name="subcategory" class="form-control m-b-5" id="id_subcategory">
                        {% if subcategories %}
                        <option value="">---------</option>
                        {% for subcategory in subcategories %}
                        {% if subcategory.0 == active_subcategory %}
                        <option value="{{ subcategory.0 }}" selected>{{ subcategory.1 }}</option>
                        {% else %}
                        <option value="{{ subcategory.0 }}">{{ subcategory.1 }}</option>
                        {% endif %}
                        {% endfor %}
                        {% endif %}
                      </select>

                      {% for error in form.subcategory.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                  <div class="field-panel">
                    <div class="field-panel-heading">
                      <label for="{{ form.service_hiring.auto_id }}">{{ form.service_hiring.label }}</label>
                    </div>
                    <div class="field-panel-body">
                      {% render_field form.service_hiring class="form-control m-b-5" %}

                      {% for error in form.service_hiring.errors %}
                      <small class="f-s-12 text-danger">{{ error }}</small>
                      {% endfor %}
                    </div>
                  </div>
                </div>
                <div class="row m-t-15 m-b-15">
                  <div class="col-sm-12">
                    <label for="{{ form.address.auto_id }}">{{ form.address.label }}</label>
                  </div>
                  <div class="col-sm-12">
                    {% render_field form.address class="form-control m-b-5" %}

                    {% for error in form.addres.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                  </div>
                </div>
                <div class="row m-t-15 m-b-15">
                  <div class="col-sm-12">
                    <table class="table scrolltable">
                      <thead>
                        <th scope="col" colspan="4" style="background-color:#bbbbbb;">Indicadores QA</th>
                      </thead>
                      <tbody>
                        {% for indicator in indicators %}
                          <tr {% if not indicator.parent %}style="background-color: #e4e7ea;"{% endif %}>
                              <td class="indicator-description">{{indicator}}</td>
                              <td class="indicator-choice text-center">{% if not indicator.parent %}<span data-name="percentage" data-id="{{ indicator.id }}"></span>{% else %}<input type="checkbox"  id="indicator-apply-{{indicator.id}}" data-name="indicator-apply" data-id="{{ indicator.id }}" value="{{ indicator.id }}" data-parent="{{ indicator.parent.id }}" title="No aplica"/>{% endif %}</td>
                              <td class="text-center indicator-choice">{% if indicator.parent %}<input type="radio" name="indicator-{{indicator.id}}" data-name="indicator" data-id="{{ indicator.id }}" data-type="Y" value="{{ indicator.id }}" data-parent="{{ indicator.parent.id }}"/>{% else %}Conforme{% endif %}</td>
                              <td class="text-center indicator-choice">{% if indicator.parent %}<input type="radio" name="indicator-{{indicator.id}}" data-name="indicator" data-id="{{ indicator.id }}" data-type="N" value="{{ indicator.id }}" data-parent="{{ indicator.parent.id }}" checked/>{% else %}No Conforme{% endif %}</td>
                          </tr>
                        {% endfor %}

                      </tbody>
                    </table>
                    {% render_field form.indicators class="d-none"%}
                    {% for error in form.indicators.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                    {% render_field form.indicators_apply class="d-none" %}
                  </div>
                </div>
                <div class="form-group row m-b-15">
                  <label for="{{ form.qa_comment.auto_id }}" class="col-form-label col-md-3">{{ form.qa_comment.label }}</label>
                  <div class="col-sm-9">
                    {% render_field form.qa_comment class="form-control m-b-5" %}
            
                    {% for error in form.qa_comment.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                  </div>
                </div>
                

                <div class="form-group row m-b-15">
                  <label for="{{ form.qa_comment.auto_id }}" class="col-form-label col-md-3"></label>
                  <div class="col-sm-9">           
                    {% for error in form.errors %}
                    <small class="f-s-12 text-danger">{{ error }}</small>
                    {% endfor %}
                  </div>
                </div>


                <input type="submit" value="Registrar" class="btn btn-primary">
                <a href="{% if active_indicators %}{% url 'call-qa-detail' object.pk %}{% else %}{% url 'call-qa-list' %}{% endif %}" class="btn btn-default">Cancelar</a>
              </form>
          

        </div>
        <!-- end panel-body -->
      </div>
        <!-- end panel -->
      </div>
    <!-- end col-6 -->
    {% endif %}
  </div>
  <!-- end row -->

  <!-- begin scroll to top btn -->
  <a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
  <!-- end scroll to top btn -->
{% endblock %}

{% block pageleveljs %}
<script src="{% static 'assets/plugins/moment/min/moment.min.js' %}"></script>
<script type="text/javascript">
  //active menu
  document.getElementById("qa_menu").classList.add("active");
  //active submenu item
  document.getElementById("callsqa_item").classList.add("active");
</script>
<script>
  $(document).ready(function () {
    var csrftoken = $("[name=csrfmiddlewaretoken]").val();
    var phone = $("#id_customer_phone").val();
    var rut = $("#id_rut").val();
    var email = $("#id_email").val();
    var address = $("#id_address").val();
    var kind = $("#id_kind").val();
    
    $('#id_indicators > option:checked').each(function(){
      val = $(this).val();
      $('input[value="'+val+'"]').prop('checked',true);
    });

    $.ajaxSetup({
        beforeSend: function(xhr, settings) {
          xhr.setRequestHeader("X-CSRFToken", csrftoken);
        }
    });

    function get_customer_data(data, type=''){
      var url = '{% url "data-by-phone" %}';
      var send_data = {'phone': data};
      if (type == 'rut'){
        url = '{% url "data-by-rut" %}';
        var send_data = {'rut': data};
      }else if (type == 'email'){
        url = '{% url "data-by-email" %}';
        var send_data = {'email': data};
      }
      $.ajax({
        type: 'POST',
        url: url,
        data: send_data
      }).done(function(data){
        if (type == ''){
          if (data['rut'] != ''){
            $('#id_rut').val(data['rut']);
          }else{
            $('#id_rut').val(rut);
          }
          if (data['email'] != ''){
            $('#id_email').val(data['email']);
          }else{
            $('#id_email').val(email);
          }
        }else if (type == 'email'){
          if (data['rut'] != ''){
            $('#id_rut').val(data['rut']);
          }else{
            $('#id_rut').val(rut);
          }
        }
        if (address.length > 0){
          $('#id_address').val(address);
        }else{
          if (data['address'] != ''){
            $('#id_address').val(data['address']);
          }else{
            $('#id_address').val('');
          }
        }
        $('#id_service').empty();
        $.each(data['services'], function(key, value){
          $('#id_service').append('<option value="'+value[0]+'" selected="selected">'+value[1]+'</option>')
        });
        if (data['services'].length == 0){
          $('#id_service').prop('required', false);
        }else{
          $('#id_service').prop('required', true);
        }
      });
    }    

    if (phone.length > 0){
      if (email.length == 0 && rut.length == 0){
        get_customer_data(phone);
      }else if (email.length > 0){
        if (rut.length == 0) {
          get_customer_data(email,'email');  
        }else{
          get_customer_data(rut,'rut');
        }
      }
    }

    if (kind == 2){
      $("#id_channel").parent().parent().removeClass("d-none");
      $("#id_channel").prop("required", true);
    }

    $('#id_customer_phone').blur(function(){
      $('#phone-format-error').addClass('d-none').text('');
      var valid = false;
      let phone = $(this).val();
      var regex = new RegExp("^(56)(9|2)[0-9]{8}$");
      if(!regex.test(phone)){
        var regex = new RegExp("^(9|2)[0-9]{8}$");
        if(regex.test(phone)){
          phone = '56' + phone;
          $(this).val(phone);
          valid = true;
        }
      }else{
        valid = true;
      }
      if (valid){
        get_customer_data(phone);
      }else{
        $('#id_service').empty();
        $('#id_rut').val('');
        $('#phone-format-error').removeClass('d-none').text('Error en formato');
      }
    });

    $('#id_email').blur(function(){
      $('#email-format-error').removeClass('d-none').text('');
      var valid = false;
      var email = $(this).val();
      var regex = new RegExp("^[a-zA-Z0-9._-]+@[a-zA-Z_]+?\.[a-zA-Z]{2,3}(\.[a-zA-Z]{2,10})?(\.[a-zA-Z]{2})?$");
      if(email.length == 0){
        valid = false;
      }else{
        if(!regex.test(email)){
            valid = false;
          }else{
            valid = true;
          }
      }
      
      if (valid){
        get_customer_data(email, 'email')
      }else{
        $('#id_service').empty();
        $('#id_rut').val('');
        $('#email-format-error').removeClass('d-none').text('Error en formato');
      }
    });

    $('#id_rut').blur(function(){
      $('#rut-format-error').removeClass('d-none').text('');
      var valid = false;
      var rut = $(this).val();
      var regex = new RegExp("^[0-9]{1,2}\.[0-9]{3}\.[0-9]{3}-[0-9K]{1}$");
      if(!regex.test(rut)){
        rut = rut.replace(/\./g, '').replace(/-/g, '');
        var extra = rut.substr(-1);
        if (isNaN(extra)){
          extra = extra.toUpperCase();
        }
        rut = rut.substr(0, rut.length - 1)
        rut = String(rut).replace(/(.)(?=(\d{3})+$)/g,'$1.') + '-' + extra;
        if (regex.test(rut)){
          $(this).val(rut);
          valid = true;
        }
      }else{
        valid = true;
      }
      
      if (valid){
        get_customer_data(rut, 'rut')
      }else{
        $('#id_service').empty();
        $('#rut-format-error').removeClass('d-none').text('Error en formato');
      }
    });


    function get_typing_childs(parent, origin){
      if(parent != '') {
        $.ajax({
          type: 'POST',
          url: '{% url "get-typing-childs" %}',
          data: {
            parent: parent
          }
        }).done(function(data){
          origin.empty();
          origin.append('<option value="">---------</option>')
          $.each(data['records'], function(key, value, index){
            origin.append('<option value="'+value.ID+'">'+value.name+'</option>')
          });
        });
      }
    }

    $('#id_typing').change(function(){
      let typing = $(this).val();
      $('#id_category').empty();
      $('#id_subcategory').empty();
      get_typing_childs(typing, $('#id_category'));
    });

    $('#id_category').change(function(){
      let category = $(this).val();
      $('#id_subcategory').empty();
      get_typing_childs(category, $('#id_subcategory'));
    });

    $('input[data-name="indicator"]').click(function(){
      val = $(this).val();
      parent = $(this).data('parent');
      selected = true;
      if ($(this).data('type') == 'N'){
        selected = false;
      }
      $('#id_indicators > option[value="'+val+'"]').prop('selected', selected);
      calculate_indicator(parent);
    });

    $('input[data-name="indicator-apply"]').click(function(){
      val = $(this).val();
      parent = $(this).data('parent');
      selected = true;
      if (!$(this).prop("checked")){
        selected = false;
      }
      $('#id_indicators_apply > option[value="'+val+'"]').prop('selected', selected);
      calculate_indicator(parent);
    });

    function calculate_indicator(parent){
      var p = 100;
      $("input[data-name='indicator'][data-parent='"+parent+"']:checked").each(function(){
        if ($(this).data("type") == "N"){
          apply = $("#indicator-apply-"+$(this).data("id")).prop("checked");
          if (!apply){
            p = 0;
            return false;
          }
        }
      });
      $("span[data-id="+parent+"]").text(p+'%')
    }



    (function calculate_all_indicators(){
      $("input[data-name='indicator-apply']").each(function(){
        $(this).prop('checked',false);
      });
      {% if apply_indicators %}      
      let apply_indicators = {{ apply_indicators }}
      apply_indicators.forEach(function(val){
        $('#indicator-apply-'+val).prop('checked',true);
      });
      {% endif %}
      {% if active_indicators %}
      active_indicators = {{ active_indicators }}
      active_indicators.forEach(function(val){
        $('input[data-name="indicator"][data-type="Y"][data-id="'+val+'"]').prop('checked',true);
      });
      {% endif %}
      $("input[data-name='indicator']:checked").each(function(){
        calculate_indicator($(this).data("parent"));
      });
    }());

    $("#id_kind").change(function(){
      var value = $(this).val();
      if (value == 2){
        $("#id_channel").parent().parent().removeClass("d-none");
        $("#id_channel").prop("required", true);
        $("#id_customer_phone").prop("required", false);
      }else{
        $("#id_channel").parent().parent().addClass("d-none");
        $("#id_channel").prop("required", false);
        $("#id_customer_phone").prop("required", true);
      }
    });


  });
</script>
{% endblock %}
